object Animals;

void CreateAnimals(ref Location)
{
	if (!IsEntity(Animals))
		CreateEntity(&Animals, "Animals");

	float midX, midY, midZ;
	SendMessage(Location, "lseee", MSG_LOCATION_EX_MSG, "GetPatchMiddlePos", &midX, &midY, &midZ);
	Animals.midY = midY;

	aref locator_group;
	aref locator;
	int n;
	int num;
	
	//DumpAttributes(Location);

	SendMessage(Animals, "l", MSG_ANIMALS_BUTTERFLIES_HIDE);
	SendMessage(Animals, "l", MSG_ANIMALS_FISHSCHOOLS_HIDE);
	SendMessage(Animals, "l", MSG_ANIMALS_SEAGULLS_HIDE);

	if (!Whr_IsRain() /*&& !Whr_IsNight() && !Whr_IsStorm() && (Location.environment.sea == "true") && (Location.environment.weather == "true")*/)
	{
		if (!Whr_IsNight())
		{
			if (!Whr_IsStorm())
			{
				// seagulls
				if(CheckAttribute(Location, "locators") && (Location.environment.weather == "true"))
				{
					SendMessage(Animals, "l", MSG_ANIMALS_SEAGULLS_SHOW);
					if(CheckAttribute(Location, "locators.seagull"))
					{
						makearef(locator_group, location.locators.seagull);
						num = GetAttributesNum(locator_group);
						for(n = 0; n < num; n++)
						{
							locator = GetAttributeN(locator_group, n);
							SendMessage(Animals, "lfff", MSG_ANIMALS_SEAGULLS_ADD, stf(locator.x), stf(locator.y), stf(locator.z));
						}
					}
				}

				// butterflies
				if (HasSubStr(Location.type, "jungle") || HasSubStr(Location.type, "garden")) // Screwface & JRH for KR jungle support for animals
				{
					SendMessage(Animals, "l", MSG_ANIMALS_BUTTERFLIES_SHOW);
				}
			}
		}
	}
	//Moved to here by Levis:
	bool crtAnimals;

	if(CheckAttribute(loc, "type"))
	{
		if((loc.type == "jungle") || (loc.type == "KR_Jungle") || (loc.type == "Den")) // KK
		{
			//Орёл
			if(rand(100) < 80)
			{
				crtAnimals = true;
				if(!IsDay()) crtAnimals = false;
				if(Whr_GetWindSpeed() > 10.0) crtAnimals = false;
				if(Whr_IsRain()) crtAnimals = false;
				if(Whr_IsStorm()) crtAnimals = false;
				if(Whr_GetFogDensity() > 0.008) crtAnimals = false;
				if(crtAnimals)
				{
					SendMessage(loc, "ls", MSG_LOCATION_EX_MSG, "AddEagle");
				}
			}
			//Ящерецы
			if(rand(100) < 95)
			{
				crtAnimals = true;
				if(Whr_IsStorm()) crtAnimals = false;
				if(Whr_GetFogDensity() > 0.008) crtAnimals = false;
				if(Whr_GetWindSpeed() > 10.0) crtAnimals = false;
				if(crtAnimals)
				{
					SendMessage(loc, "ls", MSG_LOCATION_EX_MSG, "AddLizards");
				}
			}
			//Крысы
			if(rand(100) < 50)
			{
				if(IsDay())
				{
					if(rand(100) < 50)
					{
						SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", 1 + rand(2));
					}
				}else{
					SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", 1 + rand(4));
				}
			}
		}
		if(loc.type == "Dungeon")
		{
			//Крысы
			if(rand(100) < 95)
			{
				SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", 16 + rand(16));
			}
		}
		if(loc.type == "jail")
		{
			//Крысы
			if(rand(100) < 75)
			{
				SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", 1 + rand(3));
			}
		}
		if(loc.type == "town")
		{
			//Крысы
			if(rand(100) < 35)
			{
				crtAnimals = true;
				if(Whr_IsStorm()) crtAnimals = false;
				if(Whr_GetFogDensity() > 0.008) crtAnimals = false;
				if(Whr_GetWindSpeed() > 10.0) crtAnimals = false;
				if(crtAnimals)
				{
					if(IsDay())
					{
						SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", 1 + rand(2));
					}else{
						SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", 2 + rand(4));
					}
				}
			}
		}		
	}
//JRH -->

	//changed by MAXIMUS, completed by JRH -->
	bool bAdd = false;
	if(CheckAttribute(location, "boarding") && location.boarding=="true")) bAdd = true;
	if(CheckAttribute(location, "fastreload") && location.fastreload=="ship") bAdd = true;
	if(CheckAttribute(location, "rats") && location.rats=="true")) bAdd = true;	//JRH
	if(bAdd && CheckAttribute(location, "models.always.l1"))
	{
		string locationName = location.models.always.l1;
		if(locationName=="CeresSmithy") locationName = "hold";
		if(locationName=="deck2") locationName = "deck1";
		if(locationName=="camp_deck" || locationName=="cap" || locationName=="tut_deck" || locationName=="cabin01" || locationName=="cabin02" || locationName=="cabin03" 
		|| locationName=="udeck" || locationName=="deckBig" || locationName=="deckLowVSBig" || locationName=="deckLowVSMedium" || locationName=="deckMediumVSBig"
		|| locationName=="ShipyardPirates") locationName = "capmd";
		if(locationName=="qdeck" || locationName=="deckLow" || locationName=="deckMedium" || locationName=="mh6") locationName = "capsm";

		switch(locationName)
		{
			case "hold": SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", rand(8) + rand(8)); break;
			case "deck1": SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", rand(4) + rand(4)); break;
			case "capmd": SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", rand(2)); break;
			case "capsm": SendMessage(loc, "lsl", MSG_LOCATION_EX_MSG, "AddRats", rand(1)); break;
		}
	}
	//changed by MAXIMUS <--
//<-- JRH
}

void CreateSeaAnimals()
{
	if (!IsEntity(Animals))
	{
		CreateEntity(&Animals, "Animals");
		LayerAddObject(SEA_EXECUTE, &Animals, 77);
		LayerAddObject(SEA_REALIZE, &Animals, 77);
	}

	Animals.midY = 0.0;

	SendMessage(Animals, "l", MSG_ANIMALS_BUTTERFLIES_HIDE);
	SendMessage(Animals, "l", MSG_ANIMALS_FISHSCHOOLS_SHOW);
	SendMessage(Animals, "l", MSG_ANIMALS_SEAGULLS_HIDE);

	if (!Whr_IsRain())
	{
		if (!Whr_IsNight())
		{
			if (!Whr_IsStorm())
			{
				SendMessage(Animals, "l", MSG_ANIMALS_SEAGULLS_SHOW);
				SendMessage(Animals, "lfff", MSG_ANIMALS_SEAGULLS_ADD, 0.0, 0.0, 0.0);
			}
		}
	}

}

void DeleteAnimals()
{
	if (IsEntity(Animals))
		DeleteClass(Animals);
}

